package com.lightinit.hsdatashow.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class MenuExample extends BaseExample{

    protected List<Criteria> oredCriteria;

    public MenuExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        super.clear();
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andMenucodeIsNull() {
            addCriterion("menucode is null");
            return (Criteria) this;
        }

        public Criteria andMenucodeIsNotNull() {
            addCriterion("menucode is not null");
            return (Criteria) this;
        }

        public Criteria andMenucodeEqualTo(String value) {
            addCriterion("menucode =", value, "menucode");
            return (Criteria) this;
        }

        public Criteria andMenucodeNotEqualTo(String value) {
            addCriterion("menucode <>", value, "menucode");
            return (Criteria) this;
        }

        public Criteria andMenucodeGreaterThan(String value) {
            addCriterion("menucode >", value, "menucode");
            return (Criteria) this;
        }

        public Criteria andMenucodeGreaterThanOrEqualTo(String value) {
            addCriterion("menucode >=", value, "menucode");
            return (Criteria) this;
        }

        public Criteria andMenucodeLessThan(String value) {
            addCriterion("menucode <", value, "menucode");
            return (Criteria) this;
        }

        public Criteria andMenucodeLessThanOrEqualTo(String value) {
            addCriterion("menucode <=", value, "menucode");
            return (Criteria) this;
        }

        public Criteria andMenucodeLike(String value) {
            addCriterion("menucode like", value, "menucode");
            return (Criteria) this;
        }

        public Criteria andMenucodeNotLike(String value) {
            addCriterion("menucode not like", value, "menucode");
            return (Criteria) this;
        }

        public Criteria andMenucodeIn(List<String> values) {
            addCriterion("menucode in", values, "menucode");
            return (Criteria) this;
        }

        public Criteria andMenucodeNotIn(List<String> values) {
            addCriterion("menucode not in", values, "menucode");
            return (Criteria) this;
        }

        public Criteria andMenucodeBetween(String value1, String value2) {
            addCriterion("menucode between", value1, value2, "menucode");
            return (Criteria) this;
        }

        public Criteria andMenucodeNotBetween(String value1, String value2) {
            addCriterion("menucode not between", value1, value2, "menucode");
            return (Criteria) this;
        }

        public Criteria andMenunameIsNull() {
            addCriterion("menuname is null");
            return (Criteria) this;
        }

        public Criteria andMenunameIsNotNull() {
            addCriterion("menuname is not null");
            return (Criteria) this;
        }

        public Criteria andMenunameEqualTo(String value) {
            addCriterion("menuname =", value, "menuname");
            return (Criteria) this;
        }

        public Criteria andMenunameNotEqualTo(String value) {
            addCriterion("menuname <>", value, "menuname");
            return (Criteria) this;
        }

        public Criteria andMenunameGreaterThan(String value) {
            addCriterion("menuname >", value, "menuname");
            return (Criteria) this;
        }

        public Criteria andMenunameGreaterThanOrEqualTo(String value) {
            addCriterion("menuname >=", value, "menuname");
            return (Criteria) this;
        }

        public Criteria andMenunameLessThan(String value) {
            addCriterion("menuname <", value, "menuname");
            return (Criteria) this;
        }

        public Criteria andMenunameLessThanOrEqualTo(String value) {
            addCriterion("menuname <=", value, "menuname");
            return (Criteria) this;
        }

        public Criteria andMenunameLike(String value) {
            addCriterion("menuname like", value, "menuname");
            return (Criteria) this;
        }

        public Criteria andMenunameNotLike(String value) {
            addCriterion("menuname not like", value, "menuname");
            return (Criteria) this;
        }

        public Criteria andMenunameIn(List<String> values) {
            addCriterion("menuname in", values, "menuname");
            return (Criteria) this;
        }

        public Criteria andMenunameNotIn(List<String> values) {
            addCriterion("menuname not in", values, "menuname");
            return (Criteria) this;
        }

        public Criteria andMenunameBetween(String value1, String value2) {
            addCriterion("menuname between", value1, value2, "menuname");
            return (Criteria) this;
        }

        public Criteria andMenunameNotBetween(String value1, String value2) {
            addCriterion("menuname not between", value1, value2, "menuname");
            return (Criteria) this;
        }

        public Criteria andMenuiconIsNull() {
            addCriterion("menuicon is null");
            return (Criteria) this;
        }

        public Criteria andMenuiconIsNotNull() {
            addCriterion("menuicon is not null");
            return (Criteria) this;
        }

        public Criteria andMenuiconEqualTo(String value) {
            addCriterion("menuicon =", value, "menuicon");
            return (Criteria) this;
        }

        public Criteria andMenuiconNotEqualTo(String value) {
            addCriterion("menuicon <>", value, "menuicon");
            return (Criteria) this;
        }

        public Criteria andMenuiconGreaterThan(String value) {
            addCriterion("menuicon >", value, "menuicon");
            return (Criteria) this;
        }

        public Criteria andMenuiconGreaterThanOrEqualTo(String value) {
            addCriterion("menuicon >=", value, "menuicon");
            return (Criteria) this;
        }

        public Criteria andMenuiconLessThan(String value) {
            addCriterion("menuicon <", value, "menuicon");
            return (Criteria) this;
        }

        public Criteria andMenuiconLessThanOrEqualTo(String value) {
            addCriterion("menuicon <=", value, "menuicon");
            return (Criteria) this;
        }

        public Criteria andMenuiconLike(String value) {
            addCriterion("menuicon like", value, "menuicon");
            return (Criteria) this;
        }

        public Criteria andMenuiconNotLike(String value) {
            addCriterion("menuicon not like", value, "menuicon");
            return (Criteria) this;
        }

        public Criteria andMenuiconIn(List<String> values) {
            addCriterion("menuicon in", values, "menuicon");
            return (Criteria) this;
        }

        public Criteria andMenuiconNotIn(List<String> values) {
            addCriterion("menuicon not in", values, "menuicon");
            return (Criteria) this;
        }

        public Criteria andMenuiconBetween(String value1, String value2) {
            addCriterion("menuicon between", value1, value2, "menuicon");
            return (Criteria) this;
        }

        public Criteria andMenuiconNotBetween(String value1, String value2) {
            addCriterion("menuicon not between", value1, value2, "menuicon");
            return (Criteria) this;
        }

        public Criteria andMenuactionIsNull() {
            addCriterion("menuaction is null");
            return (Criteria) this;
        }

        public Criteria andMenuactionIsNotNull() {
            addCriterion("menuaction is not null");
            return (Criteria) this;
        }

        public Criteria andMenuactionEqualTo(String value) {
            addCriterion("menuaction =", value, "menuaction");
            return (Criteria) this;
        }

        public Criteria andMenuactionNotEqualTo(String value) {
            addCriterion("menuaction <>", value, "menuaction");
            return (Criteria) this;
        }

        public Criteria andMenuactionGreaterThan(String value) {
            addCriterion("menuaction >", value, "menuaction");
            return (Criteria) this;
        }

        public Criteria andMenuactionGreaterThanOrEqualTo(String value) {
            addCriterion("menuaction >=", value, "menuaction");
            return (Criteria) this;
        }

        public Criteria andMenuactionLessThan(String value) {
            addCriterion("menuaction <", value, "menuaction");
            return (Criteria) this;
        }

        public Criteria andMenuactionLessThanOrEqualTo(String value) {
            addCriterion("menuaction <=", value, "menuaction");
            return (Criteria) this;
        }

        public Criteria andMenuactionLike(String value) {
            addCriterion("menuaction like", value, "menuaction");
            return (Criteria) this;
        }

        public Criteria andMenuactionNotLike(String value) {
            addCriterion("menuaction not like", value, "menuaction");
            return (Criteria) this;
        }

        public Criteria andMenuactionIn(List<String> values) {
            addCriterion("menuaction in", values, "menuaction");
            return (Criteria) this;
        }

        public Criteria andMenuactionNotIn(List<String> values) {
            addCriterion("menuaction not in", values, "menuaction");
            return (Criteria) this;
        }

        public Criteria andMenuactionBetween(String value1, String value2) {
            addCriterion("menuaction between", value1, value2, "menuaction");
            return (Criteria) this;
        }

        public Criteria andMenuactionNotBetween(String value1, String value2) {
            addCriterion("menuaction not between", value1, value2, "menuaction");
            return (Criteria) this;
        }

        public Criteria andMenutypeIsNull() {
            addCriterion("menutype is null");
            return (Criteria) this;
        }

        public Criteria andMenutypeIsNotNull() {
            addCriterion("menutype is not null");
            return (Criteria) this;
        }

        public Criteria andMenutypeEqualTo(Integer value) {
            addCriterion("menutype =", value, "menutype");
            return (Criteria) this;
        }

        public Criteria andMenutypeNotEqualTo(Integer value) {
            addCriterion("menutype <>", value, "menutype");
            return (Criteria) this;
        }

        public Criteria andMenutypeGreaterThan(Integer value) {
            addCriterion("menutype >", value, "menutype");
            return (Criteria) this;
        }

        public Criteria andMenutypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("menutype >=", value, "menutype");
            return (Criteria) this;
        }

        public Criteria andMenutypeLessThan(Integer value) {
            addCriterion("menutype <", value, "menutype");
            return (Criteria) this;
        }

        public Criteria andMenutypeLessThanOrEqualTo(Integer value) {
            addCriterion("menutype <=", value, "menutype");
            return (Criteria) this;
        }

        public Criteria andMenutypeIn(List<Integer> values) {
            addCriterion("menutype in", values, "menutype");
            return (Criteria) this;
        }

        public Criteria andMenutypeNotIn(List<Integer> values) {
            addCriterion("menutype not in", values, "menutype");
            return (Criteria) this;
        }

        public Criteria andMenutypeBetween(Integer value1, Integer value2) {
            addCriterion("menutype between", value1, value2, "menutype");
            return (Criteria) this;
        }

        public Criteria andMenutypeNotBetween(Integer value1, Integer value2) {
            addCriterion("menutype not between", value1, value2, "menutype");
            return (Criteria) this;
        }

        public Criteria andMenusequenceIsNull() {
            addCriterion("menusequence is null");
            return (Criteria) this;
        }

        public Criteria andMenusequenceIsNotNull() {
            addCriterion("menusequence is not null");
            return (Criteria) this;
        }

        public Criteria andMenusequenceEqualTo(Integer value) {
            addCriterion("menusequence =", value, "menusequence");
            return (Criteria) this;
        }

        public Criteria andMenusequenceNotEqualTo(Integer value) {
            addCriterion("menusequence <>", value, "menusequence");
            return (Criteria) this;
        }

        public Criteria andMenusequenceGreaterThan(Integer value) {
            addCriterion("menusequence >", value, "menusequence");
            return (Criteria) this;
        }

        public Criteria andMenusequenceGreaterThanOrEqualTo(Integer value) {
            addCriterion("menusequence >=", value, "menusequence");
            return (Criteria) this;
        }

        public Criteria andMenusequenceLessThan(Integer value) {
            addCriterion("menusequence <", value, "menusequence");
            return (Criteria) this;
        }

        public Criteria andMenusequenceLessThanOrEqualTo(Integer value) {
            addCriterion("menusequence <=", value, "menusequence");
            return (Criteria) this;
        }

        public Criteria andMenusequenceIn(List<Integer> values) {
            addCriterion("menusequence in", values, "menusequence");
            return (Criteria) this;
        }

        public Criteria andMenusequenceNotIn(List<Integer> values) {
            addCriterion("menusequence not in", values, "menusequence");
            return (Criteria) this;
        }

        public Criteria andMenusequenceBetween(Integer value1, Integer value2) {
            addCriterion("menusequence between", value1, value2, "menusequence");
            return (Criteria) this;
        }

        public Criteria andMenusequenceNotBetween(Integer value1, Integer value2) {
            addCriterion("menusequence not between", value1, value2, "menusequence");
            return (Criteria) this;
        }

        public Criteria andMenushowIsNull() {
            addCriterion("menushow is null");
            return (Criteria) this;
        }

        public Criteria andMenushowIsNotNull() {
            addCriterion("menushow is not null");
            return (Criteria) this;
        }

        public Criteria andMenushowEqualTo(Integer value) {
            addCriterion("menushow =", value, "menushow");
            return (Criteria) this;
        }

        public Criteria andMenushowNotEqualTo(Integer value) {
            addCriterion("menushow <>", value, "menushow");
            return (Criteria) this;
        }

        public Criteria andMenushowGreaterThan(Integer value) {
            addCriterion("menushow >", value, "menushow");
            return (Criteria) this;
        }

        public Criteria andMenushowGreaterThanOrEqualTo(Integer value) {
            addCriterion("menushow >=", value, "menushow");
            return (Criteria) this;
        }

        public Criteria andMenushowLessThan(Integer value) {
            addCriterion("menushow <", value, "menushow");
            return (Criteria) this;
        }

        public Criteria andMenushowLessThanOrEqualTo(Integer value) {
            addCriterion("menushow <=", value, "menushow");
            return (Criteria) this;
        }

        public Criteria andMenushowIn(List<Integer> values) {
            addCriterion("menushow in", values, "menushow");
            return (Criteria) this;
        }

        public Criteria andMenushowNotIn(List<Integer> values) {
            addCriterion("menushow not in", values, "menushow");
            return (Criteria) this;
        }

        public Criteria andMenushowBetween(Integer value1, Integer value2) {
            addCriterion("menushow between", value1, value2, "menushow");
            return (Criteria) this;
        }

        public Criteria andMenushowNotBetween(Integer value1, Integer value2) {
            addCriterion("menushow not between", value1, value2, "menushow");
            return (Criteria) this;
        }

        public Criteria andParentmenuIsNull() {
            addCriterion("parentmenu is null");
            return (Criteria) this;
        }

        public Criteria andParentmenuIsNotNull() {
            addCriterion("parentmenu is not null");
            return (Criteria) this;
        }

        public Criteria andParentmenuEqualTo(Long value) {
            addCriterion("parentmenu =", value, "parentmenu");
            return (Criteria) this;
        }

        public Criteria andParentmenuNotEqualTo(Long value) {
            addCriterion("parentmenu <>", value, "parentmenu");
            return (Criteria) this;
        }

        public Criteria andParentmenuGreaterThan(Long value) {
            addCriterion("parentmenu >", value, "parentmenu");
            return (Criteria) this;
        }

        public Criteria andParentmenuGreaterThanOrEqualTo(Long value) {
            addCriterion("parentmenu >=", value, "parentmenu");
            return (Criteria) this;
        }

        public Criteria andParentmenuLessThan(Long value) {
            addCriterion("parentmenu <", value, "parentmenu");
            return (Criteria) this;
        }

        public Criteria andParentmenuLessThanOrEqualTo(Long value) {
            addCriterion("parentmenu <=", value, "parentmenu");
            return (Criteria) this;
        }

        public Criteria andParentmenuIn(List<Long> values) {
            addCriterion("parentmenu in", values, "parentmenu");
            return (Criteria) this;
        }

        public Criteria andParentmenuNotIn(List<Long> values) {
            addCriterion("parentmenu not in", values, "parentmenu");
            return (Criteria) this;
        }

        public Criteria andParentmenuBetween(Long value1, Long value2) {
            addCriterion("parentmenu between", value1, value2, "parentmenu");
            return (Criteria) this;
        }

        public Criteria andParentmenuNotBetween(Long value1, Long value2) {
            addCriterion("parentmenu not between", value1, value2, "parentmenu");
            return (Criteria) this;
        }

        public Criteria andMenushowtypeIsNull() {
            addCriterion("menushowtype is null");
            return (Criteria) this;
        }

        public Criteria andMenushowtypeIsNotNull() {
            addCriterion("menushowtype is not null");
            return (Criteria) this;
        }

        public Criteria andMenushowtypeEqualTo(String value) {
            addCriterion("menushowtype =", value, "menushowtype");
            return (Criteria) this;
        }

        public Criteria andMenushowtypeNotEqualTo(String value) {
            addCriterion("menushowtype <>", value, "menushowtype");
            return (Criteria) this;
        }

        public Criteria andMenushowtypeGreaterThan(String value) {
            addCriterion("menushowtype >", value, "menushowtype");
            return (Criteria) this;
        }

        public Criteria andMenushowtypeGreaterThanOrEqualTo(String value) {
            addCriterion("menushowtype >=", value, "menushowtype");
            return (Criteria) this;
        }

        public Criteria andMenushowtypeLessThan(String value) {
            addCriterion("menushowtype <", value, "menushowtype");
            return (Criteria) this;
        }

        public Criteria andMenushowtypeLessThanOrEqualTo(String value) {
            addCriterion("menushowtype <=", value, "menushowtype");
            return (Criteria) this;
        }

        public Criteria andMenushowtypeLike(String value) {
            addCriterion("menushowtype like", value, "menushowtype");
            return (Criteria) this;
        }

        public Criteria andMenushowtypeNotLike(String value) {
            addCriterion("menushowtype not like", value, "menushowtype");
            return (Criteria) this;
        }

        public Criteria andMenushowtypeIn(List<String> values) {
            addCriterion("menushowtype in", values, "menushowtype");
            return (Criteria) this;
        }

        public Criteria andMenushowtypeNotIn(List<String> values) {
            addCriterion("menushowtype not in", values, "menushowtype");
            return (Criteria) this;
        }

        public Criteria andMenushowtypeBetween(String value1, String value2) {
            addCriterion("menushowtype between", value1, value2, "menushowtype");
            return (Criteria) this;
        }

        public Criteria andMenushowtypeNotBetween(String value1, String value2) {
            addCriterion("menushowtype not between", value1, value2, "menushowtype");
            return (Criteria) this;
        }

        public Criteria andAddtimeIsNull() {
            addCriterion("addtime is null");
            return (Criteria) this;
        }

        public Criteria andAddtimeIsNotNull() {
            addCriterion("addtime is not null");
            return (Criteria) this;
        }

        public Criteria andAddtimeEqualTo(Date value) {
            addCriterion("addtime =", value, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeNotEqualTo(Date value) {
            addCriterion("addtime <>", value, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeGreaterThan(Date value) {
            addCriterion("addtime >", value, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeGreaterThanOrEqualTo(Date value) {
            addCriterion("addtime >=", value, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeLessThan(Date value) {
            addCriterion("addtime <", value, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeLessThanOrEqualTo(Date value) {
            addCriterion("addtime <=", value, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeIn(List<Date> values) {
            addCriterion("addtime in", values, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeNotIn(List<Date> values) {
            addCriterion("addtime not in", values, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeBetween(Date value1, Date value2) {
            addCriterion("addtime between", value1, value2, "addtime");
            return (Criteria) this;
        }

        public Criteria andAddtimeNotBetween(Date value1, Date value2) {
            addCriterion("addtime not between", value1, value2, "addtime");
            return (Criteria) this;
        }
    }
}